﻿using Models.Events;
using Models.Jeux.Plateau;
using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models
{
    public class Display
    {
        /// <summary>
        /// Affiche le plateau de jeu . Les + correspondent aux pions noirs, les - aux pions 
        /// blancs, les X aux dames blanches et les Y aux dames noires
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void AfficherPlateau(object sender, ShowingBoardEventArgs args) 
        {
            int cpt = 0;
            Console.WriteLine(" 0  1  2  3  4  5  6  7  8  9");
            foreach (var item in args.p.ListeCases)
            {

                if (item.Pion == false)
                {
                    Console.Write("[ ]");

                }
                else
                {
                    foreach (var pion in args.p.ListePions)
                    {

                        if (item.Equals(pion.Pos) && pion is Dame && pion.CouleurPion == Couleur.BLANC)
                        {
                            Console.Write("[X]");
                        }
                        if (item.Equals(pion.Pos) && pion is Dame && pion.CouleurPion == Couleur.NOIR)
                        {
                            Console.Write("[Y]");
                        }
                        if (item.Equals(pion.Pos) && pion is not Dame && pion.CouleurPion == Couleur.BLANC)
                        {
                            Console.Write("[+]");
                        }
                        if (item.Equals(pion.Pos) && pion is not Dame && pion.CouleurPion == Couleur.NOIR)
                        {
                            Console.Write("[-]");
                        }


                    }
                }
                cpt++;
                if (cpt % 10 == 0)
                {
                    Console.WriteLine("\r");
                }
            }

        }

        /// <summary>
        /// Demande au joueur la position du pion qu'il veut déplacer et la position de l'endoit où il 
        /// souhaite le mettre. De plus , cela vérifie que les valeurs donneés sont correctes et que le déplacement est
        /// possible. Si il y a des erreurs le joueur doit re rentrer les informations.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void faireCoup(object sender, MovingPawnEventArgs args)
        {
            List<string> listeVerif = ["1","2","3","4","5","6","7","8","9"];
            
            int xp=0, yp=0, xc = 0, yc = 0 ;
            string check;
            bool verif = false;
            bool verif2=false;
            bool verif3=false;
            bool verif4=false;
            bool verif5=false;

            while (verif!=true)
            {
                while(verif2!=true && verif3!=true)
                {
                    Console.WriteLine(args.j.Nom+" donnez la position du pion a deplacer(x puis y):");
                    check = Console.ReadLine();
                    if (check != null)
                    {
                        foreach(string c in listeVerif)
                        {
                            if(check==c)
                            {
                                yp = Convert.ToInt32(check);
                                verif2=true;
                            }
                        }
                        
                    }
                    check = Console.ReadLine();
                    if (check != null)
                    {
                        foreach (string c in listeVerif)
                        {
                            if (check == c)
                            {
                                xp = Convert.ToInt32(check);
                                verif3 = true;
                            }
                        }
                        
                    }
                   
                    
                }

                while (verif4 != true && verif5 != true)
                {
                    Console.WriteLine(args.j.Nom + " donnez la position de la cible(x puis y):");
                    check = Console.ReadLine();
                    if (check != null)
                    {
                        foreach (string c in listeVerif)
                        {
                            if (check == c)
                            {
                                yc = Convert.ToInt32(check);
                                verif4 = true;
                            }
                        }

                    }
                    check = Console.ReadLine();
                    if (check != null)
                    {
                        foreach (string c in listeVerif)
                        {
                            if (check == c)
                            {
                                xc = Convert.ToInt32(check);
                                verif5 = true;
                            }
                        }

                    }
                    
                }

                Case c1 = args.plateau.rechercheCase(xp, yp);
                Case c2 = args.plateau.rechercheCase(xc, yc);
                Pion p1 = args.plateau.recherchePion(c1);
                verif = args.plateau.deplacer(p1, c2,args.j);

                Case cBG = args.plateau.rechercheCase(xc - 1, yc - 1);
                Case cHG = args.plateau.rechercheCase(xc + 1, yc -1 );
                Case cBD = args.plateau.rechercheCase(xc - 1, yc + 1);
                Case cHD = args.plateau.rechercheCase(xc + 1, yc + 1);
                if(cHG!=null)
                {
                    if (cHG.Pion == true)
                    {
                        Case cHGHG = args.plateau.rechercheCase(xc + 2, yc - 2);
                        if (cHGHG != null)
                        {
                            if (cHGHG.Pion == false)
                            {
                                args.plateau.AfficherPlateau();
                                args.plateau.MovePawn(args.j);
                                
                            }
                        }
                    }
                }
                if(cBD!=null)
                {
                    if (cBD.Pion == true)
                    {
                        Case cBDBD = args.plateau.rechercheCase(xc - 2, yc + 2);
                        if (cBDBD != null)
                        {
                            if (cBDBD.Pion == false)
                            {
                                args.plateau.AfficherPlateau();
                                args.plateau.MovePawn(args.j);
                                
                            }
                        }
                    }
                }
                
                if(cHD!=null)
                {
                    if (cHD.Pion == true)
                    {
                        Case cHDHD = args.plateau.rechercheCase(xc + 2, yc + 2);
                        if (cHDHD != null)
                        {
                            if (cHDHD.Pion == false)
                            {
                                args.plateau.AfficherPlateau();
                                args.plateau.MovePawn(args.j);
                                
                            }
                        }

                    }
                }
                
                if(cBG!=null)
                {
                    if (cBG.Pion == true)
                    {
                        Case cBGBG = args.plateau.rechercheCase(xc - 2, yc - 2);
                        if (cBGBG != null)
                        {
                            if (cBGBG.Pion == false)
                            {
                                args.plateau.AfficherPlateau();
                                args.plateau.MovePawn(args.j);
                                
                            }
                        }
                    }
                }
                

             
                if(verif==false) 
                {
                    Console.WriteLine("Erreur déplacement non valide veuillez recommencer!");
                    verif2 = false;
                    verif3=false;
                    verif4=false;
                    verif5=false;
                }

            }
        
        }

        /// <summary>
        /// Demande au joueur son nom et le lui attribut
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void EntrerNoms(object sender, EnterPlayerNameEventArgs args)
        {
            string nom;

            Console.WriteLine("Joueur quel est votre nom ?");
            nom = Console.ReadLine();
            args.joueur.Nom = nom;

            Console.WriteLine("Vous vous appelez donc "+ args.joueur.Nom);


        }

        /// <summary>
        /// Affiche le nom  d'un joueur
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void AfficherNomJoueur(object sender, ShowingPlayerNameEventArgs args)
        {
            Console.Write(args.j.Nom);

        }
        /// <summary>
        /// Affiche le gagnant de la partie
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void AfficherGagnant(object sender, ShowingWinnerEventArgs args)
        {
            Console.WriteLine("Bravo "+args.j.Nom + "tu a gagné!!");
        }
    }
}
