﻿using Models.Jeux;
using Models.Jeux.Plateau;
using Models.Peristance;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Models
{
    public class Game: INotifyPropertyChanged
    {

        public event PropertyChangedEventHandler? PropertyChanged;

        void OnPropertyChanged([CallerMemberName] string propertyName = null)
            => PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));

        public Game(ISerializer ser)
        {
            serializer = ser;
        }


        public ISerializer Serializer
        {
            get
            {
                return serializer;
            }
        }

        private ISerializer serializer;

        public Partie Partie
        {
            get 
            {
                return partie;
            }
            set 
            { 
                partie = value;
                OnPropertyChanged();
            }
            
        }

        private Partie partie;


        public Joueur Joueur1
        {
            get
            {
                return joueur1;
            }
            set
            {
                joueur1 = value;
                OnPropertyChanged();
            }
        }
        private Joueur joueur1;

        public Joueur Joueur2
        {
            get
            {
                return joueur2;
            }
            set
            {
                joueur2 = value;
                OnPropertyChanged();
            }
        }
        private Joueur joueur2;

        public void LancerPartie()
        {
            Joueur1 = new Joueur();
            Joueur2 = new Joueur();
            Partie = new Partie(Joueur1, Joueur2);

            
        }
    }
}
