﻿using Models.Jeux;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestUnit
{
    public class PartieTest
    {
        [Fact]
        public void TestConstructorValid()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            Assert.NotNull(p);
            Assert.Equal(j1, p.Joueur1);
            Assert.Equal(j2, p.Joueur2);
            Assert.Equal(j1, p.JoueurCourrant);
            Assert.Equal(Couleur.BLANC, p.Joueur1.CouleurDePion);
            Assert.Equal(Couleur.NOIR, p.Joueur2.CouleurDePion);
            Assert.NotNull(p.Plateau);
        }
        [Fact]
        public void TestSetJoueurCourrant()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            p.JoueurCourrant = j2;

            Assert.Equal(j2, p.JoueurCourrant);
     
        }
        [Fact]
        public void TestSetJoueur1()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            p.Joueur1 = j2;

            Assert.Equal(j2, p.Joueur1);

        }
        [Fact]
        public void TestSetJoueur2()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            p.Joueur2 = j1;

            Assert.Equal(j1, p.Joueur2);

        }
        [Fact]
        public void TestSetPlateau()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);
            Plateau p1 = new Plateau();

            p.Plateau = p1;

            Assert.Equal(p1, p.Plateau);

        }
        [Fact]
        public void TestAGagnerJoueur2()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            p.Joueur2.NbPions = 20;


            Assert.Equal(2, p.Agagner());
        }
        [Fact]
        public void TestAGagnerJoueur1()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);

            p.Joueur1.NbPions = 20;


            Assert.Equal(1, p.Agagner());
        }
        [Fact]
        public void TestAGagnerPersonne()
        {
            Joueur j1 = new Joueur();
            Joueur j2 = new Joueur();
            Partie p = new Partie(j1, j2);



            Assert.Equal(0, p.Agagner());
        }
    }
}
